use std::fs;

use pest::Parser;
use pest_derive::Parser;

#[derive(Parser)]
#[grammar = "rpy.pest"]
struct RpyParser;

pub fn parse(file_path: &str) {
    let unparsed_file = fs::read_to_string(file_path).expect("cannot find file");
    let file = RpyParser::parse(Rule::file, &unparsed_file)
        .expect("unsuccessful parse") // unwrap the parse result
        .next().unwrap(); // get and unwrap the `file` rule; never fails
    for line in file.into_inner() {
        match line.as_rule() {
            Rule::line => {
                println!("Line:");
                for token in line.into_inner() {
                    match token.as_rule() {
                        Rule::token => {
                            println!("{}", token.as_str());
                        },
                        _ => {
                            println!("{}", token.as_str());
                        }
                    }
                }
                println!()
            },
            Rule::EOI => (),
            _ => unreachable!(),
        }
    }
}
